﻿package {

import flash.display.Sprite;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.net.URLRequest;
import flash.net.URLVariables;
import flash.display.Loader;
import flash.system.LoaderContext;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.text.TextFieldAutoSize;
import flash.events.*;


[SWF("width"="700","height"="560")]

public class TAView extends Sprite {

var loader:Loader
var img:BitmapData;
var imgx:int=0;
var imgy:int=0;
var form:TextFormat = new TextFormat("Arial", 10, 0x000000, true);

	
public function TAView(){
//	STrace.on(taview);
	taview();
}

function taview():void{
	var host:String = loaderInfo.parameters.host;
 	var request:URLRequest =new URLRequest("http://"+host+".appspot.com/do");
	var vars:URLVariables = new URLVariables();
	vars.cmd = "getproject";
	vars.id = loaderInfo.parameters.id;
	request.data = vars;
	var loaderContext:LoaderContext = new LoaderContext ();
	loaderContext.checkPolicyFile = true;
	loader=new Loader ();
	loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadComplete);
	loader.load(request, loaderContext);
	loader.scaleX = stage.stageWidth/1400;
	loader.scaleY = stage.stageHeight/1120;
	addChild(loader);
}

function loadComplete(event:Event):void {	
	img = (loader.contentLoaderInfo.content as Bitmap).bitmapData;
	imgreadln(20);
	var str = (imgreadln(10000));
	str = str.substr(1,str.length-2);
	var data:Array = new TokenStream(str).readList();
	var blocks:Array = data[0];
	for(var i in blocks) {
		var block:Array=blocks[i];
		addBlock(block[0],block[1],block[2],block[3]);
	}
}

function addBlock(type:String, x:Number, y:Number, label:String):void{
	var cl:Class = BlockShapes[type+'_block'];
	if(cl==null) {STrace.print(type); return;}
	var spr:Sprite = new Sprite();
	spr.x=x; spr.y=y;
	spr.scaleX = stage.stageWidth/700;
	spr.scaleY = stage.stageHeight/560;
	var b:Bitmap = new cl() as Bitmap;
	spr.addChild(b);
	if(type=="number") {addLabel(spr, label, 35, -2);}
	if(type=="procedure") {addLabel(spr, label, 24, 5);}
	if(type=="start") {addLabel(spr, label, 30, 9);}
	if(type=="global") {addLabel(spr, label, 35, -2);}
	if(type=="setglobal") {addLabel(spr, label, 24, 16);}
	addChild(spr);	
}

function addLabel(spr:Sprite, label:String, x:Number, y:Number):void{
	var tf = new TextField();
	tf.type = "dynamic";
	tf.antiAliasType = "advanced";
	tf.autoSize = TextFieldAutoSize.CENTER;
	tf.x = x; tf.y = y;
	tf.text = label;
	tf.setTextFormat(form);
	spr.addChild(tf);
}

function imgreadln (max:Number):String {
	var res:String = "";
	var c, cksum:int=0;
	for (var i:int=0;i<max;i++) {
 		c=imgrb();
   	cksum =  0xffff & (cksum + c);
  	if (c == 0xff) {
  		if  (cksum != imgrb() + (imgrb() << 8)) STrace.print( "bad checksum");
    	return res;}
   	res = res + String.fromCharCode(c);
  }
	return res;
}


function imgrb():Number {
	var p1:Number= img.getPixel(imgx, imgy);
	var p2:Number= img.getPixel(imgx, imgy + 1); 
	var p3:Number= img.getPixel(imgx, imgy + 2); 
 	imginc();
	return (getbit (p1, 0)) + (getbit (p1, 8) << 1) + (getbit (p1, 16) << 2) +
         (getbit (p2, 0) << 3) + (getbit (p2, 8) << 4) + (getbit (p2, 16) << 5) +
         (getbit (p3, 0) << 6) + (getbit (p3, 8) << 7);
}

function imginc():void {
	imgx++
	if (imgx < 500) return;
	imgx = 0;
	imgy+=3;
}

function getbit (word:Number, n:Number):Number { return 1 & (word >> n); }


}}